/**
 * @file
 * Javascript to integrate the clipboard.js library with Drupal.
 */

(function ($, Drupal, drupalSettings) {
  'use strict';

  Drupal.behaviors.user_referral = {
      attach: function (context, settings) {
        var elements = 'a.referral-link-copy-button, input.referral-link-copy-button, button.referral-link-copy-button';
        // Initialize clipboard.js.
        $(once('user-referral-processed', elements, context), context).each(function() {
          Drupal.user_referral_clipboard = new ClipboardJS(elements);

          // Process successful copy.
          Drupal.user_referral_clipboard.on('success', function (e) {
              var $button = $(e.trigger);

              var copied_label = $button .attr('data-copied-label');
              $button .html(copied_label);

              setTimeout(function () {
                $button.html($button .attr('data-copy-label'));
              }, 1500);

          });
        });
      }
  };
})(jQuery, Drupal, drupalSettings);