<?php

namespace Drupal\user_referral_webform\Element;

use Drupal\webform\Element\WebformCompositeBase;

/**
 * Provides a webform element for an referrer element.
 *
 * @FormElement("webform_referrer")
 */
class WebformReferrer extends WebformCompositeBase {

  /**
   * {@inheritdoc}
   */
  public function getInfo() {
    return parent::getInfo() + ['#theme' => 'webform_composite_referrer'];
  }

  /**
   * {@inheritdoc}
   */
  public static function getCompositeElements(array $element) {
    $elements = [];
    $elements['referrer_uid'] = [
      '#type' => 'textfield',
      '#title' => t('Referrer UID'),
    ];
    $elements['referral_type'] = [
      '#type' => 'textfield',
      '#title' => t('Referral Type'),
    ];

    $elements['#cache'] = [
      'contexts' => [
        'user_referral_cookie',
      ],
    ];

    return $elements;
  }

}
